--- src/kbd.c.orig	2013-03-27 09:56:38.000000000 +0900
+++ src/kbd.c	2013-07-13 15:16:42.470309000 +0900
@@ -92,6 +92,16 @@
     NULL
 };
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+static const char *kbd98Defaults[] = {
+    "Protocol",		"standard",
+    "XkbRules",		"xfree98",
+    "XkbModel",		"pc98",
+    "XkbLayout",	"jp",
+    NULL
+};
+#endif
+
 static char *xkb_rules;
 static char *xkb_model;
 static char *xkb_layout;
@@ -154,7 +164,13 @@
     pInfo->fd = -1;
     pInfo->dev = NULL;
 
-    defaults = kbdDefaults;
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())
+       defaults = kbd98Defaults;
+    else
+#endif
+       defaults = kbdDefaults;
+
     xf86CollectInputOptions(pInfo, defaults
 #if GET_ABI_MAJOR(ABI_XINPUT_VERSION) < 12
             , NULL
@@ -434,12 +450,18 @@
    * physical keyboard key.
    */
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+  if (!xf86IsPc98()) {
+#endif
   state = XkbStateFieldFromRec(&keyc->xkbInfo->state);
 
   if (((state & AltMask) == AltMask) && (scanCode == KEY_SysReqest))
     scanCode = KEY_Print;
   else if (scanCode == KEY_Break)
     scanCode = KEY_Pause;
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+  }
+#endif
 
   xf86PostKeyboardEvent(device, scanCode + MIN_KEYCODE, down);
 }
