--- src/mga_driver.c.orig	2012-09-28 10:37:15.000000000 +0900
+++ src/mga_driver.c	2013-07-13 15:10:55.497506000 +0900
@@ -2195,7 +2195,12 @@
     /*
      * Reset card if it isn't primary one
      */
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if ( (!pMga->Primary && !pMga->FBDev) || xf86IsPc98() )
+#else
     if ( (!pMga->Primary && !pMga->FBDev) )
+#endif
+
         MGASoftReset(pScrn);
 
     if (pScrn->videoRam == 0) {
@@ -2897,6 +2902,13 @@
 	vgaHWProtect(pScrn, FALSE);
     }
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98()) {
+       if (pMga->Chipset == PCI_CHIP_MGA2064)  outb(0xfac, 0x01);
+       else                                    outb(0xfac, 0x02);
+    }
+#endif
+
     /* Reset tagfifo*/ 
 	if (pMga->is_G200ER) 
     {
@@ -3689,6 +3701,10 @@
     MGARestore(pScrn);
     vgaHWLock(hwp);
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
 #ifdef MGADRI
     if (pMga->directRenderingEnabled) {
         pScreen = xf86ScrnToScreen(pScrn);
@@ -3785,6 +3801,10 @@
 
     pScrn->vtSema = FALSE;
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
     xf86ClearPrimInitDone(pScrn->entityList[0]);
 
     if(pMga->BlockHandler)
