--- src/mga_driver.c.orig	2013-12-05 10:15:53.000000000 +0900
+++ src/mga_driver.c	2014-01-25 18:00:14.010730000 +0900
@@ -2224,7 +2224,12 @@
     /*
      * Reset card if it isn't primary one
      */
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if ( (!pMga->Primary && !pMga->FBDev) || xf86IsPc98() )
+#else
     if ( (!pMga->Primary && !pMga->FBDev) )
+#endif
+
         MGASoftReset(pScrn);
 
     if (pScrn->videoRam == 0) {
@@ -2981,6 +2986,13 @@
 	vgaHWProtect(pScrn, FALSE);
     }
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98()) {
+       if (pMga->Chipset == PCI_CHIP_MGA2064)  outb(0xfac, 0x01);
+       else                                    outb(0xfac, 0x02);
+    }
+#endif
+
     /* Reset tagfifo*/ 
 	if (pMga->is_G200ER) 
     {
@@ -3775,6 +3787,10 @@
     MGARestore(pScrn);
     vgaHWLock(hwp);
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
 #ifdef MGADRI
     if (pMga->directRenderingEnabled) {
         pScreen = xf86ScrnToScreen(pScrn);
@@ -3871,6 +3887,10 @@
 
     pScrn->vtSema = FALSE;
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
     xf86ClearPrimInitDone(pScrn->entityList[0]);
 
     if(pMga->BlockHandler)
