--- src/savage_driver.c.orig	2013-09-20 05:14:25.000000000 +0900
+++ src/savage_driver.c	2014-01-25 18:01:53.353340000 +0900
@@ -137,7 +137,7 @@
 
 #define iabs(a)	((int)(a)>0?(a):(-(a)))
 
-/*#define TRACEON*/
+#define TRACEON
 #ifdef TRACEON
 #define TRACE(prms)	ErrorF prms
 #else
@@ -1084,6 +1084,7 @@
     ClockRangePtr clockRanges;
     char *s = NULL;
     unsigned char config1, m, n, n1, n2, sr8, cr66 = 0, tmp;
+    unsigned char sr30, cr36;
     int mclk;
     vgaHWPtr hwp;
     int vgaCRIndex, vgaCRReg;
@@ -1734,6 +1735,7 @@
 	    psav->IsSecondary = TRUE;
 	    pSavageEnt->pSecondaryScrn = pScrn;
 	    psav->TvOn = pSavageEnt->TvOn;
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "Secondary\n");
 	} else {
 	    SavageEntPtr pSavageEnt = SavageEntPriv(pScrn);
 
@@ -1742,6 +1744,7 @@
 	    psav->IsPrimary = TRUE;
 	    pSavageEnt->pPrimaryScrn        = pScrn;
 	    pSavageEnt->TvOn = psav->TvOn;
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "Primary\n");
 	}
     }
 
@@ -1778,12 +1781,25 @@
 
     vgaCRIndex = psav->vgaIOBase + 4;
     vgaCRReg = psav->vgaIOBase + 5;
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "vgaIOBase = %04x\n",psav->vgaIOBase);
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "MapBase   = %04x\n",psav->MapBase);
 
     xf86EnableIO();
+
+#if 1
+    if (xf86GetVerbosity() > 1)  {
+       TRACE(("before unlock\n"));
+       SavagePrintRegs(pScrn);
+    }
+#endif
+
     /* unprotect CRTC[0-7] */
     VGAOUT8(vgaCRIndex, 0x11);
     tmp = VGAIN8(vgaCRReg);
     VGAOUT8(vgaCRReg, tmp & 0x7f);
+#if 0
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "cr11 = %02x\n",tmp);
+#endif
 
     /* unlock extended regs */
     VGAOUT16(vgaCRIndex, 0x4838);
@@ -1794,10 +1810,692 @@
     tmp = VGAIN8(vgaCRReg);
     VGAOUT8(vgaCRReg, tmp & ~0x01);
 
+#if 1
+    if (xf86GetVerbosity() > 1)  {
+       TRACE(("after unlock\n"));
+       SavagePrintRegs(pScrn);
+    }
+#endif
+
+#if 1
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "cr40 = %02x\n",tmp);
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "bpp   = %d\n",pScrn->bitsPerPixel);
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "depth = %d\n",pScrn->depth);
+#endif
+
     /* unlock sys regs */
     VGAOUT8(vgaCRIndex, 0x38);
     VGAOUT8(vgaCRReg, 0x48);
 
+if ( xf86IsPc98() )  {
+/*if ( 0 )  {*/
+    if ( psav->Chipset == S3_SAVAGE4 )  {
+#ifdef AAA  /*  SR0x  */
+       VGAOUT8(0x3c4, 0x02);  VGAOUT8(0x3c5, 0x03);
+       VGAOUT8(0x3c4, 0x04);  VGAOUT8(0x3c5, 0x02);
+TRACE(("SR0\n"));
+#endif
+
+#ifndef AAA  /*  SR1x  */
+       VGAOUT8(0x3c4, 0x10);  VGAOUT8(0x3c5, 0x41);  /*  MCLK 125  */
+       VGAOUT8(0x3c4, 0x11);  VGAOUT8(0x3c5, 0x67);
+
+#ifdef BBB
+       VGAOUT8(0x3c4, 0x12);  VGAOUT8(0x3c5, 0x01);
+       VGAOUT8(0x3c4, 0x13);  VGAOUT8(0x3c5, 0x77);  /*  CC  */
+
+       VGAOUT8(0x3c4, 0x15);  VGAOUT8(0x3c5, 0x03);
+/*     VGAOUT8(0x3c4, 0x16);  VGAOUT8(0x3c5, 0x6e);*/  /*  CC  */
+/*     VGAOUT8(0x3c4, 0x17);  VGAOUT8(0x3c5, 0xa4);*/  /*  CC  */
+       VGAOUT8(0x3c4, 0x18);  VGAOUT8(0x3c5, 0x40);
+
+       VGAOUT8(0x3c4, 0x1a);  VGAOUT8(0x3c5, 0x01);
+       VGAOUT8(0x3c4, 0x1c);  VGAOUT8(0x3c5, 0x5d);
+#endif  /*  BBB  */
+TRACE(("SR1\n"));
+#endif
+
+#ifndef AAA  /*  SR2x  */
+       VGAOUT8(0x3c4, 0x28);  VGAOUT8(0x3c5, 0xff);
+TRACE(("SR2\n"));
+#endif
+
+/*  common. essential for correct root window  */
+#ifndef AAA  /*  SR3x  */
+       VGAOUT8(0x3c4, 0x31);  VGAOUT8(0x3c5, 0x06);
+       VGAOUT8(0x3c4, 0x32);  VGAOUT8(0x3c5, 0x41);
+       VGAOUT8(0x3c4, 0x33);  VGAOUT8(0x3c5, 0x76);
+
+       VGAOUT8(0x3c4, 0x36);  VGAOUT8(0x3c5, 0x01);
+       VGAOUT8(0x3c4, 0x37);  VGAOUT8(0x3c5, 0x52);
+       VGAOUT8(0x3c4, 0x38);  VGAOUT8(0x3c5, 0x5d);
+       VGAOUT8(0x3c4, 0x39);  VGAOUT8(0x3c5, 0x05);
+TRACE(("SR3\n"));
+#endif
+
+#ifdef AAA  /*  SR5x  */
+/*     VGAOUT8(0x3c4, 0x5a);  VGAOUT8(0x3c5, 0x34);*/
+/*     VGAOUT8(0x3c4, 0x5b);  VGAOUT8(0x3c5, 0x08);*/
+TRACE(("SR5\n"));
+#endif
+
+#ifdef AAA  /*  SR6x  */
+       VGAOUT8(0x3c4, 0x60);  VGAOUT8(0x3c5, 0xff);
+       VGAOUT8(0x3c4, 0x61);  VGAOUT8(0x3c5, 0xff);
+       VGAOUT8(0x3c4, 0x62);  VGAOUT8(0x3c5, 0xfb);
+       VGAOUT8(0x3c4, 0x63);  VGAOUT8(0x3c5, 0xef);
+       VGAOUT8(0x3c4, 0x64);  VGAOUT8(0x3c5, 0xff);
+       VGAOUT8(0x3c4, 0x65);  VGAOUT8(0x3c5, 0x35);
+       VGAOUT8(0x3c4, 0x66);  VGAOUT8(0x3c5, 0xff);
+       VGAOUT8(0x3c4, 0x67);  VGAOUT8(0x3c5, 0xbf);
+       VGAOUT8(0x3c4, 0x68);  VGAOUT8(0x3c5, 0xff);
+       VGAOUT8(0x3c4, 0x69);  VGAOUT8(0x3c5, 0xf7);
+       VGAOUT8(0x3c4, 0x6a);  VGAOUT8(0x3c5, 0xee);
+       VGAOUT8(0x3c4, 0x6b);  VGAOUT8(0x3c5, 0x5f);
+       VGAOUT8(0x3c4, 0x6c);  VGAOUT8(0x3c5, 0xfe);
+       VGAOUT8(0x3c4, 0x6d);  VGAOUT8(0x3c5, 0xdb);
+       VGAOUT8(0x3c4, 0x6e);  VGAOUT8(0x3c5, 0xdf);
+       VGAOUT8(0x3c4, 0x6f);  VGAOUT8(0x3c5, 0xd7);
+TRACE(("SR6\n"));
+#endif
+
+#ifdef AAA  /*  CR0x  */
+       VGAOUT8(vgaCRIndex, 0x00);  VGAOUT8(vgaCRReg, 0x5f);
+       VGAOUT8(vgaCRIndex, 0x01);  VGAOUT8(vgaCRReg, 0x4f);
+       VGAOUT8(vgaCRIndex, 0x02);  VGAOUT8(vgaCRReg, 0x50);
+       VGAOUT8(vgaCRIndex, 0x03);  VGAOUT8(vgaCRReg, 0x82);
+       VGAOUT8(vgaCRIndex, 0x04);  VGAOUT8(vgaCRReg, 0x55);
+       VGAOUT8(vgaCRIndex, 0x05);  VGAOUT8(vgaCRReg, 0x81);
+       VGAOUT8(vgaCRIndex, 0x06);  VGAOUT8(vgaCRReg, 0xbf);
+       VGAOUT8(vgaCRIndex, 0x07);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x08);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x09);  VGAOUT8(vgaCRReg, 0x4f);
+       VGAOUT8(vgaCRIndex, 0x0a);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0b);  VGAOUT8(vgaCRReg, 0x0f);
+       VGAOUT8(vgaCRIndex, 0x0c);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0d);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0e);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x0f);  VGAOUT8(vgaCRReg, 0xff);
+TRACE(("CR0\n"));
+#endif
+
+#ifdef AAA  /*  CR1x  */
+       VGAOUT8(vgaCRIndex, 0x10);  VGAOUT8(vgaCRReg, 0x9c);
+       VGAOUT8(vgaCRIndex, 0x11);  VGAOUT8(vgaCRReg, 0x0e);
+       VGAOUT8(vgaCRIndex, 0x12);  VGAOUT8(vgaCRReg, 0x8f);
+       VGAOUT8(vgaCRIndex, 0x13);  VGAOUT8(vgaCRReg, 0x28);
+       VGAOUT8(vgaCRIndex, 0x14);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x15);  VGAOUT8(vgaCRReg, 0x96);
+       VGAOUT8(vgaCRIndex, 0x16);  VGAOUT8(vgaCRReg, 0xb9);
+       VGAOUT8(vgaCRIndex, 0x17);  VGAOUT8(vgaCRReg, 0xa3);
+       VGAOUT8(vgaCRIndex, 0x18);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x19);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1a);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1b);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1c);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1d);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1e);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1f);  VGAOUT8(vgaCRReg, 0xff);
+TRACE(("CR1\n"));
+#endif
+
+#ifdef AAA  /*  CR2x  */
+       VGAOUT8(vgaCRIndex, 0x20);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x21);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x22);  VGAOUT8(vgaCRReg, 0x07);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x23);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x24);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x25);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x26);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x27);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x28);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x29);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2a);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2b);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2c);  VGAOUT8(vgaCRReg, 0xbf);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2d);  VGAOUT8(vgaCRReg, 0x8a);
+       VGAOUT8(vgaCRIndex, 0x2e);  VGAOUT8(vgaCRReg, 0x22);
+       VGAOUT8(vgaCRIndex, 0x2f);  VGAOUT8(vgaCRReg, 0x04);
+TRACE(("CR2\n"));
+#endif
+
+#ifndef AAA  /*  CR3x  */
+/*
+       VGAOUT8(vgaCRIndex, 0x31);  VGAOUT8(vgaCRReg, 0x05);
+       VGAOUT8(vgaCRIndex, 0x32);  VGAOUT8(vgaCRReg, 0x40);
+       VGAOUT8(vgaCRIndex, 0x33);  VGAOUT8(vgaCRReg, 0x08);
+       VGAOUT8(vgaCRIndex, 0x34);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x35);  VGAOUT8(vgaCRReg, 0x00);
+*/
+       VGAOUT8(vgaCRIndex, 0x36);  cr36 = VGAIN8(vgaCRReg);
+       if ( cr36 == 0x17 )  {   /*  first setting after power on  */
+          VGAOUT8(0x3c4, 0x30);  sr30 = VGAIN8(0x3c5);
+
+          VGAOUT16(vgaCRIndex, 0xa539);
+          VGAOUT8(vgaCRIndex, 0x36);
+          if      ( sr30 == 0x04 )  VGAOUT8(vgaCRReg, 0x57); /*   8MB  */
+          else if ( sr30 == 0x00 )  VGAOUT8(vgaCRReg, 0xb7); /*  32MB  */
+       }
+TRACE(("CR36\n"));
+
+       VGAOUT8(vgaCRIndex, 0x38);  VGAOUT8(vgaCRReg, 0x7b);
+       VGAOUT8(vgaCRIndex, 0x39);  VGAOUT8(vgaCRReg, 0xb8);
+/*
+       VGAOUT8(vgaCRIndex, 0x37);  VGAOUT8(vgaCRReg, 0xbb);
+       VGAOUT8(vgaCRIndex, 0x3a);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x3b);  VGAOUT8(vgaCRReg, 0x5e);
+       VGAOUT8(vgaCRIndex, 0x3c);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x3e);  VGAOUT8(vgaCRReg, 0x00);
+*/
+TRACE(("CR3\n"));
+#endif
+
+#ifdef AAA  /*  CR4x  */
+       VGAOUT8(vgaCRIndex, 0x40);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x41);  VGAOUT8(vgaCRReg, 0x32);
+       VGAOUT8(vgaCRIndex, 0x42);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x43);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x44);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x45);  VGAOUT8(vgaCRReg, 0x00);
+/*
+       VGAOUT8(vgaCRIndex, 0x46);  VGAOUT8(vgaCRReg, 0x07);
+       VGAOUT8(vgaCRIndex, 0x47);  VGAOUT8(vgaCRReg, 0xfb);
+       VGAOUT8(vgaCRIndex, 0x48);  VGAOUT8(vgaCRReg, 0xf8);
+       VGAOUT8(vgaCRIndex, 0x49);  VGAOUT8(vgaCRReg, 0xfd);
+       VGAOUT8(vgaCRIndex, 0x4a);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x4b);  VGAOUT8(vgaCRReg, 0xf7);
+
+       VGAOUT8(vgaCRIndex, 0x4d);  VGAOUT8(vgaCRReg, 0xef);
+       VGAOUT8(vgaCRIndex, 0x4e);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x4f);  VGAOUT8(vgaCRReg, 0xff);
+*/
+TRACE(("CR4\n"));
+#endif
+
+#ifdef AAA  /*  CR5x  */
+       VGAOUT8(vgaCRIndex, 0x52);  VGAOUT8(vgaCRReg, 0x40);
+       VGAOUT8(vgaCRIndex, 0x53);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x59);  VGAOUT8(vgaCRReg, 0xf0);
+       VGAOUT8(vgaCRIndex, 0x5e);  VGAOUT8(vgaCRReg, 0x08);
+TRACE(("CR5\n"));
+#endif
+
+#ifndef AAA  /*  CR6x  */
+/*
+       VGAOUT8(vgaCRIndex, 0x60);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x61);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x62);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x63);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x64);  VGAOUT8(vgaCRReg, 0x00);
+
+       VGAOUT8(vgaCRIndex, 0x65);  VGAOUT8(vgaCRReg, 0x04);
+       VGAOUT8(vgaCRIndex, 0x66);  VGAOUT8(vgaCRReg, 0x88);
+       VGAOUT8(vgaCRIndex, 0x67);  VGAOUT8(vgaCRReg, 0x00);
+*/
+
+       VGAOUT16(vgaCRIndex, 0xa539);
+       VGAOUT8(vgaCRIndex, 0x68);  VGAOUT8(vgaCRReg, 0x7f);
+TRACE(("CR68\n"));
+
+/*
+       VGAOUT8(vgaCRIndex, 0x69);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x6d);  VGAOUT8(vgaCRReg, 0x11);
+       VGAOUT8(vgaCRIndex, 0x6e);  VGAOUT8(vgaCRReg, 0xbf);
+       VGAOUT8(vgaCRIndex, 0x6f);  VGAOUT8(vgaCRReg, 0xf6);
+*/
+TRACE(("CR6\n"));
+#endif
+
+#ifndef AAA  /*  CR7x  */
+       VGAOUT8(vgaCRIndex, 0x70);  VGAOUT8(vgaCRReg, 0x90);
+       VGAOUT8(vgaCRIndex, 0x71);  VGAOUT8(vgaCRReg, 0xc0);
+       VGAOUT8(vgaCRIndex, 0x72);  VGAOUT8(vgaCRReg, 0x07);
+       VGAOUT8(vgaCRIndex, 0x73);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x74);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x75);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x76);  VGAOUT8(vgaCRReg, 0x0f);
+       VGAOUT8(vgaCRIndex, 0x77);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x78);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x79);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x7a);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x7b);  VGAOUT8(vgaCRReg, 0x1f);
+       VGAOUT8(vgaCRIndex, 0x7c);  VGAOUT8(vgaCRReg, 0x17);
+       VGAOUT8(vgaCRIndex, 0x7d);  VGAOUT8(vgaCRReg, 0x17);
+       VGAOUT8(vgaCRIndex, 0x7e);  VGAOUT8(vgaCRReg, 0x17);
+       VGAOUT8(vgaCRIndex, 0x7f);  VGAOUT8(vgaCRReg, 0x17);  /*  CC  */
+TRACE(("CR7\n"));
+#endif
+
+#ifdef AAA  /*  CR8x  */
+/*
+       VGAOUT8(vgaCRIndex, 0x80);  VGAOUT8(vgaCRReg, 0x11);
+*/
+/*     VGAOUT8(vgaCRIndex, 0x81);  VGAOUT8(vgaCRReg, 0xfc);
+       VGAOUT8(vgaCRIndex, 0x82);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x83);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x84);  VGAOUT8(vgaCRReg, 0x11);
+       VGAOUT8(vgaCRIndex, 0x85);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x86);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x87);  VGAOUT8(vgaCRReg, 0x00);
+*/
+       VGAOUT8(vgaCRIndex, 0x86);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x88);  VGAOUT8(vgaCRReg, 0x10);
+
+/*
+       VGAOUT8(vgaCRIndex, 0x89);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8a);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8b);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8c);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8d);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8e);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x8f);  VGAOUT8(vgaCRReg, 0x10);
+*/
+TRACE(("CR8\n"));
+#endif
+
+#ifdef AAA  /*  CR9x  */
+       VGAOUT8(vgaCRIndex, 0x90);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x91);  VGAOUT8(vgaCRReg, 0x4f);
+/*
+       VGAOUT8(vgaCRIndex, 0x94);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x95);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x96);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x97);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x98);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x99);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9a);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9b);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9c);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9d);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9e);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x9f);  VGAOUT8(vgaCRReg, 0x00);
+*/
+TRACE(("CR9\n"));
+#endif
+
+#ifdef AAA  /*  CRax  */
+       VGAOUT8(vgaCRIndex, 0xa0);  VGAOUT8(vgaCRReg, 0x0c);
+       VGAOUT8(vgaCRIndex, 0xa5);  VGAOUT8(vgaCRReg, 0x09);
+       VGAOUT8(vgaCRIndex, 0xa6);  VGAOUT8(vgaCRReg, 0x20);
+TRACE(("CRa\n"));
+#endif
+
+#ifdef AAA  /*  CRbx  */
+/*     VGAOUT8(vgaCRIndex, 0xb0);  VGAOUT8(vgaCRReg, 0xf7);*/
+       VGAOUT8(vgaCRIndex, 0xb1);  VGAOUT8(vgaCRReg, 0x0f);
+TRACE(("CRb\n"));
+#endif
+
+#ifdef AAA
+       /* unlock sys regs 0xa5 to 0xa0 */
+       VGAOUT16(vgaCRIndex, 0xa039);
+#endif
+    }
+    else if ( psav->Chipset == S3_SAVAGE2000 )  {
+#ifdef AAA  /*  SR0x  */
+       VGAOUT8(0x3c4, 0x01);  VGAOUT8(0x3c5, 0x01);
+       VGAOUT8(0x3c4, 0x02);  VGAOUT8(0x3c5, 0x0f);
+       VGAOUT8(0x3c4, 0x04);  VGAOUT8(0x3c5, 0x06);
+       VGAOUT8(0x3c4, 0x08);  VGAOUT8(0x3c5, 0x06);
+#endif
+
+#ifndef AAA  /*  SR1x  */
+       VGAOUT8(0x3c4, 0x10);  VGAOUT8(0x3c5, 0x21);  /*  MCLK 150  */
+       VGAOUT8(0x3c4, 0x11);  VGAOUT8(0x3c5, 0x3d);
+
+#ifdef BBB
+       VGAOUT8(0x3c4, 0x10);  VGAOUT8(0x3c5, 0x41);  /*  MCLK  50  */
+       VGAOUT8(0x3c4, 0x11);  VGAOUT8(0x3c5, 0x28);
+       VGAOUT8(0x3c4, 0x10);  VGAOUT8(0x3c5, 0x41);  /*  MCLK 125  */
+       VGAOUT8(0x3c4, 0x11);  VGAOUT8(0x3c5, 0x67);
+
+       VGAOUT8(0x3c4, 0x12);  VGAOUT8(0x3c5, 0x81);
+       VGAOUT8(0x3c4, 0x13);  VGAOUT8(0x3c5, 0x6f);
+
+       VGAOUT8(0x3c4, 0x15);  VGAOUT8(0x3c5, 0x03);
+
+       VGAOUT8(0x3c4, 0x18);  VGAOUT8(0x3c5, 0x00);
+
+/*  cannot change !  */
+       VGAOUT8(0x3c4, 0x16);  VGAOUT8(0x3c5, 0xf5);  f6, f6
+       VGAOUT8(0x3c4, 0x17);  VGAOUT8(0x3c5, 0x22);  f3, e6
+
+       VGAOUT8(0x3c4, 0x1b);
+       if      ( pScrn->depth ==  8 )  VGAOUT8(0x3c5, 0x18);
+       else if ( pScrn->depth == 16 )  VGAOUT8(0x3c5, 0x18);
+       else if ( pScrn->depth == 24 )  VGAOUT8(0x3c5, 0x00);
+
+       VGAOUT8(0x3c4, 0x1c);  VGAOUT8(0x3c5, 0x5d);
+       VGAOUT8(0x3c4, 0x1f);  VGAOUT8(0x3c5, 0x00);
+#endif  /*  BBB  */
+#endif
+
+#ifndef AAA  /*  SR2x  */
+       VGAOUT8(0x3c4, 0x22);  VGAOUT8(0x3c5, 0xc1);
+       VGAOUT8(0x3c4, 0x23);  VGAOUT8(0x3c5, 0x28);
+       VGAOUT8(0x3c4, 0x24);  VGAOUT8(0x3c5, 0xc2);
+       VGAOUT8(0x3c4, 0x25);  VGAOUT8(0x3c5, 0x3d);
+
+       VGAOUT8(0x3c4, 0x27);  VGAOUT8(0x3c5, 0x04);
+       VGAOUT8(0x3c4, 0x28);  VGAOUT8(0x3c5, 0xf0);
+#endif
+
+#ifndef AAA  /*  SR3x  */
+       VGAOUT8(0x3c4, 0x32);  VGAOUT8(0x3c5, 0x41);
+       VGAOUT8(0x3c4, 0x33);  VGAOUT8(0x3c5, 0x67);
+       VGAOUT8(0x3c4, 0x34);  VGAOUT8(0x3c5, 0x02);
+       VGAOUT8(0x3c4, 0x35);  VGAOUT8(0x3c5, 0x22);
+       VGAOUT8(0x3c4, 0x36);  VGAOUT8(0x3c5, 0x4f);
+       VGAOUT8(0x3c4, 0x37);  VGAOUT8(0x3c5, 0x02);
+       VGAOUT8(0x3c4, 0x38);  VGAOUT8(0x3c5, 0xf9);
+#endif
+
+#ifdef AAA  /*  SR4x  */
+       VGAOUT8(0x3c4, 0x41);  VGAOUT8(0x3c5, 0x0f);
+       VGAOUT8(0x3c4, 0x42);  VGAOUT8(0x3c5, 0x0f);
+#endif
+
+#ifdef AAA  /*  SR5x  */
+       VGAOUT8(0x3c4, 0x59);  VGAOUT8(0x3c5, 0x70);
+
+       VGAOUT8(0x3c4, 0x5a);
+       if      ( pScrn->depth ==  8 )  VGAOUT8(0x3c5, 0x3a);
+       else if ( pScrn->depth == 16 )  VGAOUT8(0x3c5, 0x3a);
+       else if ( pScrn->depth == 24 )  VGAOUT8(0x3c5, 0x3b);
+
+       VGAOUT8(0x3c4, 0x5b);  VGAOUT8(0x3c5, 0x09);
+       VGAOUT8(0x3c4, 0x5c);  VGAOUT8(0x3c5, 0x77);
+       VGAOUT8(0x3c4, 0x5d);  VGAOUT8(0x3c5, 0x37);
+       VGAOUT8(0x3c4, 0x5e);  VGAOUT8(0x3c5, 0x00);
+       VGAOUT8(0x3c4, 0x5f);  VGAOUT8(0x3c5, 0x00);
+#endif
+
+#ifdef AAA  /*  SR6x  */
+       VGAOUT8(0x3c4, 0x60);  VGAOUT8(0x3c5, 0xc8);
+       VGAOUT8(0x3c4, 0x63);  VGAOUT8(0x3c5, 0x60);
+       VGAOUT8(0x3c4, 0x68);  VGAOUT8(0x3c5, 0x9f);
+       VGAOUT8(0x3c4, 0x6a);  VGAOUT8(0x3c5, 0xd2);
+       VGAOUT8(0x3c4, 0x6d);  VGAOUT8(0x3c5, 0x7d);
+       VGAOUT8(0x3c4, 0x6e);  VGAOUT8(0x3c5, 0x61);
+
+       if ( pScrn->depth == 8 ) {
+          VGAOUT8(0x3c4, 0x61);  VGAOUT8(0x3c5, 0x8b);
+          VGAOUT8(0x3c4, 0x62);  VGAOUT8(0x3c5, 0xc4);
+          VGAOUT8(0x3c4, 0x64);  VGAOUT8(0x3c5, 0xdf);
+          VGAOUT8(0x3c4, 0x65);  VGAOUT8(0x3c5, 0x82);
+          VGAOUT8(0x3c4, 0x66);  VGAOUT8(0x3c5, 0x0b);
+          VGAOUT8(0x3c4, 0x67);  VGAOUT8(0x3c5, 0x28);
+          VGAOUT8(0x3c4, 0x69);  VGAOUT8(0x3c5, 0x74);
+          VGAOUT8(0x3c4, 0x6b);  VGAOUT8(0x3c5, 0xd7);
+          VGAOUT8(0x3c4, 0x6c);  VGAOUT8(0x3c5, 0x61);
+          VGAOUT8(0x3c4, 0x6f);  VGAOUT8(0x3c5, 0xf7);
+       }
+       else if ( pScrn->depth == 16 ) {
+          VGAOUT8(0x3c4, 0x61);  VGAOUT8(0x3c5, 0x8f);
+          VGAOUT8(0x3c4, 0x62);  VGAOUT8(0x3c5, 0xc4);
+          VGAOUT8(0x3c4, 0x64);  VGAOUT8(0x3c5, 0x9f);
+          VGAOUT8(0x3c4, 0x65);  VGAOUT8(0x3c5, 0x82);
+          VGAOUT8(0x3c4, 0x66);  VGAOUT8(0x3c5, 0x0a);
+          VGAOUT8(0x3c4, 0x67);  VGAOUT8(0x3c5, 0x2a);
+          VGAOUT8(0x3c4, 0x69);  VGAOUT8(0x3c5, 0x74);
+          VGAOUT8(0x3c4, 0x6b);  VGAOUT8(0x3c5, 0x73);
+          VGAOUT8(0x3c4, 0x6c);  VGAOUT8(0x3c5, 0x61);
+          VGAOUT8(0x3c4, 0x6f);  VGAOUT8(0x3c5, 0xb7);
+       }
+       else if ( pScrn->depth == 24 ) {
+          VGAOUT8(0x3c4, 0x61);  VGAOUT8(0x3c5, 0xcf);
+          VGAOUT8(0x3c4, 0x62);  VGAOUT8(0x3c5, 0xd4);
+          VGAOUT8(0x3c4, 0x64);  VGAOUT8(0x3c5, 0xdf);
+          VGAOUT8(0x3c4, 0x65);  VGAOUT8(0x3c5, 0x8a);
+          VGAOUT8(0x3c4, 0x66);  VGAOUT8(0x3c5, 0x0b);
+          VGAOUT8(0x3c4, 0x67);  VGAOUT8(0x3c5, 0xaa);
+          VGAOUT8(0x3c4, 0x69);  VGAOUT8(0x3c5, 0x75);
+          VGAOUT8(0x3c4, 0x6b);  VGAOUT8(0x3c5, 0xf7);
+          VGAOUT8(0x3c4, 0x6c);  VGAOUT8(0x3c5, 0xe1);
+          VGAOUT8(0x3c4, 0x6f);  VGAOUT8(0x3c5, 0xf7);
+       }
+#endif
+
+#ifdef AAA  /*  CR0x  */
+       VGAOUT8(vgaCRIndex, 0x00);  VGAOUT8(vgaCRReg, 0xce);
+       VGAOUT8(vgaCRIndex, 0x01);  VGAOUT8(vgaCRReg, 0x9f);
+       VGAOUT8(vgaCRIndex, 0x02);  VGAOUT8(vgaCRReg, 0xa0);
+       VGAOUT8(vgaCRIndex, 0x03);  VGAOUT8(vgaCRReg, 0x0f);
+       VGAOUT8(vgaCRIndex, 0x04);  VGAOUT8(vgaCRReg, 0xa3);
+       VGAOUT8(vgaCRIndex, 0x05);  VGAOUT8(vgaCRReg, 0x15);
+       VGAOUT8(vgaCRIndex, 0x06);  VGAOUT8(vgaCRReg, 0x28);
+       VGAOUT8(vgaCRIndex, 0x07);  VGAOUT8(vgaCRReg, 0x5a);
+       VGAOUT8(vgaCRIndex, 0x08);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x09);  VGAOUT8(vgaCRReg, 0x60);
+       VGAOUT8(vgaCRIndex, 0x0a);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0b);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0c);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0d);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x0e);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x0f);  VGAOUT8(vgaCRReg, 0x00);
+#endif
+
+#ifdef AAA  /*  CR1x  */
+       VGAOUT8(vgaCRIndex, 0x10);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x11);  VGAOUT8(vgaCRReg, 0x03);
+       VGAOUT8(vgaCRIndex, 0x12);  VGAOUT8(vgaCRReg, 0xff);
+
+       VGAOUT8(vgaCRIndex, 0x13);
+       if      ( pScrn->depth ==  8 )  VGAOUT8(vgaCRReg, 0x40);
+       else if ( pScrn->depth == 16 )  VGAOUT8(vgaCRReg, 0x80);
+       else if ( pScrn->depth == 24 )  VGAOUT8(vgaCRReg, 0xa0);
+
+       VGAOUT8(vgaCRIndex, 0x14);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x15);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x16);  VGAOUT8(vgaCRReg, 0x28);
+       VGAOUT8(vgaCRIndex, 0x17);  VGAOUT8(vgaCRReg, 0xe3);
+       VGAOUT8(vgaCRIndex, 0x18);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x19);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1a);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1b);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1c);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1d);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1e);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x1f);  VGAOUT8(vgaCRReg, 0xff);
+#endif
+
+#ifdef AAA  /*  CR2x  */
+       VGAOUT8(vgaCRIndex, 0x20);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x21);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x22);  VGAOUT8(vgaCRReg, 0x00);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x23);  VGAOUT8(vgaCRReg, 0xff);
+       VGAOUT8(vgaCRIndex, 0x24);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x25);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x26);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x27);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x28);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x29);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2a);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2b);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x2c);  VGAOUT8(vgaCRReg, 0x20);  /*  CC  */
+#endif
+
+#ifndef AAA  /*  CR3x  */
+#ifdef BBB
+       VGAOUT8(vgaCRIndex, 0x31);  VGAOUT8(vgaCRReg, 0x0c);
+       VGAOUT8(vgaCRIndex, 0x32);  VGAOUT8(vgaCRReg, 0x40);
+       VGAOUT8(vgaCRIndex, 0x33);  VGAOUT8(vgaCRReg, 0x08);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x34);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x35);  VGAOUT8(vgaCRReg, 0x00);
+#endif  /*  BBB  */
+
+       VGAOUT16(vgaCRIndex, 0xa539);
+       VGAOUT8(vgaCRIndex, 0x36);  VGAOUT8(vgaCRReg, 0xbf);
+
+       VGAOUT8(vgaCRIndex, 0x38);  VGAOUT8(vgaCRReg, 0x7b);
+       VGAOUT8(vgaCRIndex, 0x39);  VGAOUT8(vgaCRReg, 0xb8);
+
+#ifdef BBB
+       VGAOUT8(vgaCRIndex, 0x37);  VGAOUT8(vgaCRReg, 0x3b);
+       VGAOUT8(vgaCRIndex, 0x3a);  VGAOUT8(vgaCRReg, 0x11);
+       VGAOUT8(vgaCRIndex, 0x3b);  VGAOUT8(vgaCRReg, 0xb9);
+       VGAOUT8(vgaCRIndex, 0x3c);  VGAOUT8(vgaCRReg, 0x10);
+       VGAOUT8(vgaCRIndex, 0x3d);  VGAOUT8(vgaCRReg, 0x00);
+
+       VGAOUT8(vgaCRIndex, 0x3e);  VGAOUT8(vgaCRReg, 0x1e);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x3f);  VGAOUT8(vgaCRReg, 0x1e);  /*  CC  */
+#endif  /*  BBB  */
+#endif
+
+#ifdef AAA  /*  CR4x  */
+       VGAOUT8(vgaCRIndex, 0x40);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x41);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x45);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x46);  VGAOUT8(vgaCRReg, 0x07);
+       VGAOUT8(vgaCRIndex, 0x47);  VGAOUT8(vgaCRReg, 0x60);
+       VGAOUT8(vgaCRIndex, 0x4b);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x4c);  VGAOUT8(vgaCRReg, 0x3e);
+#endif
+
+#ifdef AAA  /*  CR5x  */
+       if ( pScrn->depth == 8 ) {
+          VGAOUT8(vgaCRIndex, 0x50);  VGAOUT8(vgaCRReg, 0xc1);
+          VGAOUT8(vgaCRIndex, 0x51);  VGAOUT8(vgaCRReg, 0x10);
+       }
+       else if ( pScrn->depth == 16 ) {
+          VGAOUT8(vgaCRIndex, 0x50);  VGAOUT8(vgaCRReg, 0xc1);
+          VGAOUT8(vgaCRIndex, 0x51);  VGAOUT8(vgaCRReg, 0x20);
+       }
+       else if ( pScrn->depth == 24 ) {
+          VGAOUT8(vgaCRIndex, 0x50);  VGAOUT8(vgaCRReg, 0xc0);
+          VGAOUT8(vgaCRIndex, 0x51);  VGAOUT8(vgaCRReg, 0x00);
+       }
+       VGAOUT8(vgaCRIndex, 0x52);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x53);  VGAOUT8(vgaCRReg, 0x80);
+       VGAOUT8(vgaCRIndex, 0x58);  VGAOUT8(vgaCRReg, 0x13);
+       VGAOUT8(vgaCRIndex, 0x59);  VGAOUT8(vgaCRReg, 0x24);
+       VGAOUT8(vgaCRIndex, 0x5a);  VGAOUT8(vgaCRReg, 0x28);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0x5b);  VGAOUT8(vgaCRReg, 0x28);  /*  CC  */
+
+       VGAOUT8(vgaCRIndex, 0x5e);  VGAOUT8(vgaCRReg, 0x51);
+       VGAOUT8(vgaCRIndex, 0x5f);  VGAOUT8(vgaCRReg, 0x02);
+#endif
+
+#ifdef AAA  /*  CR6x  */
+       VGAOUT8(vgaCRIndex, 0x66);  VGAOUT8(vgaCRReg, 0x09);
+
+       VGAOUT8(vgaCRIndex, 0x67);
+       if      ( pScrn->depth ==  8 )  VGAOUT8(vgaCRReg, 0x4c);
+       else if ( pScrn->depth == 16 )  VGAOUT8(vgaCRReg, 0xdc);
+       else if ( pScrn->depth == 24 )  VGAOUT8(vgaCRReg, 0x0c);
+
+       VGAOUT8(vgaCRIndex, 0x68);  VGAOUT8(vgaCRReg, 0xdc);
+       VGAOUT8(vgaCRIndex, 0x6c);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0x6d);  VGAOUT8(vgaCRReg, 0x11);
+       VGAOUT8(vgaCRIndex, 0x6f);  VGAOUT8(vgaCRReg, 0x01);
+#endif
+
+#ifndef AAA  /*  CR7x  */
+#ifndef BBB  /*  PC-98  */
+       VGAOUT8(vgaCRIndex, 0x70);  VGAOUT8(vgaCRReg, 0x90);
+       VGAOUT8(vgaCRIndex, 0x71);  VGAOUT8(vgaCRReg, 0xc0);
+
+       VGAOUT8(vgaCRIndex, 0x73);  VGAOUT8(vgaCRReg, 0x05);
+       VGAOUT8(vgaCRIndex, 0x74);  VGAOUT8(vgaCRReg, 0x44);
+/*     VGAOUT8(vgaCRIndex, 0x75);  VGAOUT8(vgaCRReg, 0x40);*/
+       VGAOUT8(vgaCRIndex, 0x76);  VGAOUT8(vgaCRReg, 0xf0);
+       VGAOUT8(vgaCRIndex, 0x77);  VGAOUT8(vgaCRReg, 0x05);
+       VGAOUT8(vgaCRIndex, 0x78);  VGAOUT8(vgaCRReg, 0x04);
+
+/*     VGAOUT8(vgaCRIndex, 0x7b);  VGAOUT8(vgaCRReg, 0x20);*/
+#else  /*  AT  */
+       VGAOUT8(vgaCRIndex, 0x70);  VGAOUT8(vgaCRReg, 0x30);
+
+       VGAOUT8(vgaCRIndex, 0x73);  VGAOUT8(vgaCRReg, 0x05);
+       VGAOUT8(vgaCRIndex, 0x74);  VGAOUT8(vgaCRReg, 0x44);
+       VGAOUT8(vgaCRIndex, 0x75);  VGAOUT8(vgaCRReg, 0x61);
+       VGAOUT8(vgaCRIndex, 0x76);  VGAOUT8(vgaCRReg, 0xf0);
+       VGAOUT8(vgaCRIndex, 0x77);  VGAOUT8(vgaCRReg, 0x05);
+       VGAOUT8(vgaCRIndex, 0x78);  VGAOUT8(vgaCRReg, 0x04);
+
+       VGAOUT8(vgaCRIndex, 0x7b);  VGAOUT8(vgaCRReg, 0x00);
+#endif  /*  BBB  */
+#endif
+
+#ifdef AAA  /*  CR8x  */
+       VGAOUT8(vgaCRIndex, 0x81);  VGAOUT8(vgaCRReg, 0xc1);
+       VGAOUT8(vgaCRIndex, 0x82);  VGAOUT8(vgaCRReg, 0x0f);
+       VGAOUT8(vgaCRIndex, 0x83);  VGAOUT8(vgaCRReg, 0x1a);
+       VGAOUT8(vgaCRIndex, 0x84);  VGAOUT8(vgaCRReg, 0x01);
+       VGAOUT8(vgaCRIndex, 0x85);  VGAOUT8(vgaCRReg, 0x03);
+       VGAOUT8(vgaCRIndex, 0x86);  VGAOUT8(vgaCRReg, 0x2c);
+       VGAOUT8(vgaCRIndex, 0x87);  VGAOUT8(vgaCRReg, 0xf8);
+       VGAOUT8(vgaCRIndex, 0x88);  VGAOUT8(vgaCRReg, 0xd0);
+       VGAOUT8(vgaCRIndex, 0x89);  VGAOUT8(vgaCRReg, 0x40);
+#endif
+
+#ifdef AAA  /*  CR9x  */
+       if ( pScrn->depth == 8 ) {
+          VGAOUT8(vgaCRIndex, 0x90);  VGAOUT8(vgaCRReg, 0x01);
+          VGAOUT8(vgaCRIndex, 0x91);  VGAOUT8(vgaCRReg, 0x3f);
+       }
+       else if ( pScrn->depth == 16 ) {
+          VGAOUT8(vgaCRIndex, 0x90);  VGAOUT8(vgaCRReg, 0x02);
+          VGAOUT8(vgaCRIndex, 0x91);  VGAOUT8(vgaCRReg, 0x7f);
+       }
+       else if ( pScrn->depth == 24 ) {
+          VGAOUT8(vgaCRIndex, 0x90);  VGAOUT8(vgaCRReg, 0x00);
+          VGAOUT8(vgaCRIndex, 0x91);  VGAOUT8(vgaCRReg, 0x9f);
+       }
+#endif
+
+#ifdef AAA  /*  CRax  */
+       VGAOUT8(vgaCRIndex, 0xa0);  VGAOUT8(vgaCRReg, 0x0f);
+       VGAOUT8(vgaCRIndex, 0xa5);  VGAOUT8(vgaCRReg, 0x08);
+       VGAOUT8(vgaCRIndex, 0xa6);  VGAOUT8(vgaCRReg, 0x20);
+/*
+       VGAOUT8(vgaCRIndex, 0xaa);  VGAOUT8(vgaCRReg, 0x00);
+       VGAOUT8(vgaCRIndex, 0xac);  VGAOUT8(vgaCRReg, 0x00);
+*/
+#endif
+
+#ifdef AAA  /*  CRbx  */
+       VGAOUT8(vgaCRIndex, 0xb1);  VGAOUT8(vgaCRReg, 0x10);
+#ifdef BBB
+       VGAOUT8(vgaCRIndex, 0xb6);  VGAOUT8(vgaCRReg, 0x1b);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0xb7);  VGAOUT8(vgaCRReg, 0x14);  /*  CC  */
+       VGAOUT8(vgaCRIndex, 0xb8);  VGAOUT8(vgaCRReg, 0x40);  /*  use ?  */
+#endif  /*  BBB  */
+#endif  /*  AAA  */
+
+#ifdef AAA
+    VGAOUT8(0x3c2, 0x00);  VGAOUT8(0x3c2, 0x2f);
+    VGAOUT8(0x3c0, 0x00);  VGAOUT8(0x3c0, 0x20);
+#endif
+
+#ifdef AAA  /*  GR  */
+    VGAOUT8(0x3ce, 0x00);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x01);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x02);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x03);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x04);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x05);  VGAOUT8(0x3cf, 0x00);
+    VGAOUT8(0x3ce, 0x06);  VGAOUT8(0x3cf, 0x05);
+    VGAOUT8(0x3ce, 0x07);  VGAOUT8(0x3cf, 0x0f);
+    VGAOUT8(0x3ce, 0x08);  VGAOUT8(0x3cf, 0xff);
+#endif
+
+#ifdef AAA  /*  AR cannot set  */
+    VGAOUT8(0x3c0, 0x31);  VGAOUT8(0x3c0, 0x01);
+    VGAOUT8(0x3c0, 0x33);  VGAOUT8(0x3c0, 0x0f);
+    VGAOUT8(0x3c0, 0x38);  VGAOUT8(0x3c0, 0x01);
+    VGAOUT8(0x3c0, 0x3a);  VGAOUT8(0x3c0, 0x0f);
+#endif
+   }
+
+#if 1
+    if (xf86GetVerbosity() > 1)  {
+       TRACE(("after modification for PC-98\n"));
+       SavagePrintRegs(pScrn);
+    }
+#endif
+}
+
     {
 	Gamma zeros = {0.0, 0.0, 0.0};
 
@@ -1838,8 +2536,16 @@
 	     * can do it different...
 	     */
 	    VGAOUT8(vgaCRIndex, 0x68);	/* memory control 1 */
+#ifdef AAA
 	    if( (VGAIN8(vgaCRReg) & 0xC0) == (0x01 << 6) )
 		RamSavage4[1] = 8;
+#else
+            tmp = VGAIN8(vgaCRReg);
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "CR36 = %x\n",config1);
+xf86DrvMsg(pScrn->scrnIndex, X_INFO, "CR68 = %x\n",tmp);
+	    if( (tmp & 0xC0) == (0x01 << 6) )
+		RamSavage4[1] = 8;
+#endif
 
 	    /*FALLTHROUGH*/
 
@@ -1968,6 +2674,7 @@
     /* reset graphics engine to avoid memory corruption */
     VGAOUT8(vgaCRIndex, 0x66);
     cr66 = VGAIN8(vgaCRReg);
+/*  xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "cr66 = %02x\n",cr66);*/
     VGAOUT8(vgaCRReg, cr66 | 0x02);
     usleep(10000);
 
@@ -2030,6 +2737,12 @@
     xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "Detected current MCLK value of %1.3f MHz\n",
 	       mclk / 1000.0);
 
+#if 0
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "sr8  = %02x\n",sr8);
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "sr10 = %02x\n",n);
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "sr11 = %02x\n",m);
+#endif
+
     pScrn->maxHValue = 2048 << 3;	/* 11 bits of h_total 8-pixel units */
     pScrn->maxVValue = 2048;		/* 11 bits of v_total */
     pScrn->virtualX = pScrn->display->virtualX;
@@ -2435,7 +3148,7 @@
 	psav->ModeStructInit = TRUE;
     }
 
-#if 0
+#if 1
     if (xf86GetVerbosity() > 1)
 	SavagePrintRegs(pScrn);
 #endif
@@ -2658,6 +3371,13 @@
     	psav->LockHeld = 0;
 #endif
 
+#if 1
+    if (xf86GetVerbosity() > 1)  {
+       TRACE(("after UseBIOS\n"));
+       SavagePrintRegs(pScrn);
+    }
+#endif
+
 	return;
     }
 
@@ -2907,6 +3627,18 @@
 
     vgaHWProtect(pScrn, FALSE);
 
+#if 1
+    if ( Entering==TRUE && xf86GetVerbosity() > 1 )  {
+       TRACE(("before switch screen\n"));
+       SavagePrintRegs(pScrn);
+    }
+#endif
+
+    if ( xf86IsPc98() )  {
+       TRACE(("SavageWriteMode(%c)\n",(Entering==TRUE)? 't':'f'));
+       if ( Entering == TRUE )  outb(0xfac,0x01);
+       else                     outb(0xfac,0x00);
+    }
 
 #ifdef SAVAGEDRI
     if (psav->directRenderingEnabled)
@@ -3153,6 +3885,8 @@
 {
     SavagePtr psav = SAVPTR(pScrn);
 
+    TRACE(("SavageInitStatus()\n"));
+
     switch( psav->Chipset ) {
 	case S3_SAVAGE3D:
 	case S3_SAVAGE_MX:
@@ -3731,6 +4465,7 @@
 
     dclk = mode->Clock;
     new->CR67 = 0x00;
+    xf86DrvMsg(pScrn->scrnIndex, X_PROBED, "DCLK is %1.3f MHz\n",dclk/1000.0);
 
     switch( pScrn->depth ) {
     case 8:
@@ -3783,6 +4518,7 @@
 	 * Either BIOS use is disabled, or we failed to find a suitable
 	 * match.  Fall back to traditional register-crunching.
 	 */
+TRACE(("SavageModeInit(traditional)\n"));
 
 	VGAOUT8(vgaCRIndex, 0x3a);
 	tmp = VGAIN8(vgaCRReg);
@@ -3806,9 +4542,11 @@
 		new->CR55 |= 0x10;
 #endif
 
-	new->SR15 = 0x03 | 0x80;
-	new->SR18 = 0x00;
+	if      ( psav->Chipset == S3_SAVAGE4    )  new->SR15 = 0x03;
+	else if ( psav->Chipset == S3_SAVAGE2000 )  new->SR15 = 0x03;
+	else                                        new->SR15 = 0x03 | 0x80;
 
+	new->SR18 = 0x00;
 
 	/* enable gamma correction */
 	if( pScrn->depth == 24 )
@@ -4460,13 +5198,20 @@
 SavagePrintRegs(ScrnInfoPtr pScrn)
 {
     SavagePtr psav = SAVPTR(pScrn);
-    unsigned char i;
-    int vgaCRIndex = 0x3d4;
-    int vgaCRReg = 0x3d5;
+    unsigned char i, j, k;
+    int l;
+    int vgaCRIndex, vgaCRReg, vgaIR;
+
+    vgaCRIndex = psav->vgaIOBase + 4;
+    vgaCRReg = psav->vgaIOBase + 5;
+    vgaIR = psav->vgaIOBase + 0xa;
+
+    ErrorF( "0x3cc = %02x\n", VGAIN8(0x3cc) );
 
     ErrorF( "SR    x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xA xB xC xD xE xF" );
 
-    for( i = 0; i < 0x70; i++ ) {
+    for( l = 0; l <= 0x6f; l++ ) {
+	i = l;
 	if( !(i % 16) )
 	    ErrorF( "\nSR%xx ", i >> 4 );
 	VGAOUT8( 0x3c4, i );
@@ -4475,13 +5220,47 @@
 
     ErrorF( "\n\nCR    x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xA xB xC xD xE xF" );
 
-    for( i = 0; i < 0xB7; i++ ) {
+    for( l = 0; l <= 0xbf; l++ ) {
+	i = l;
 	if( !(i % 16) )
 	    ErrorF( "\nCR%xx ", i >> 4 );
 	VGAOUT8( vgaCRIndex, i );
 	ErrorF( " %02x", VGAIN8(vgaCRReg) );
     }
 
+#ifdef AAA
+    ErrorF( "\n\nGR    x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xA xB xC xD xE xF" );
+    for ( i = 0; i <= 0x0f; i++ )  {
+       if( !(i % 16) )
+           ErrorF( "\nGR%xx ", i >> 4 );
+       VGAOUT8(0x3ce, i);
+       ErrorF(" %02x",VGAIN8(0x3cf));
+    }
+
+    VGAIN8(vgaIR); /* preset AR flip-flop by reading 3DA */
+    i = VGAIN8(0x3c0);
+    j = i&0x20;
+    ErrorF( "\n\n0x3c0 = %02x -> %02x\n",i,j);
+
+    ErrorF( "pt    x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xA xB xC xD xE xF" );
+    for ( i = 0; i <= 0x1f; i++ )  {
+       if( !(i % 16) )
+           ErrorF( "\npt%xx ", i >> 4 );
+       k = (i & ~0x20) | j;
+       ErrorF(" %02x",k);
+    }
+
+    ErrorF( "\n\nAR    x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xA xB xC xD xE xF" );
+
+    for ( i = 0; i <= 0x1f; i++ )  {
+       if( !(i % 16) )
+           ErrorF( "\nAR%xx ", i >> 4 );
+       VGAIN8(vgaIR); /* preset AR flip-flop by reading 3DA */
+       VGAOUT8(0x3c0, (i & ~0x20) | j);
+       ErrorF(" %02x",VGAIN8(0x3c1));
+    }
+#endif
+
     ErrorF("\n\n");
 }
 
