--- ./src/mga_driver.c.orig	2015-02-20 04:51:35.000000000 +0900
+++ ./src/mga_driver.c	2016-09-11 15:34:11.000000000 +0900
@@ -2102,7 +2102,12 @@
     /*
      * Reset card if it isn't primary one
      */
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if ( (!pMga->Primary && !pMga->FBDev) || xf86IsPc98() )
+#else
     if ( (!pMga->Primary && !pMga->FBDev) )
+#endif
+
         MGASoftReset(pScrn);
 
     if (pScrn->videoRam == 0) {
@@ -2859,6 +2864,13 @@
 	vgaHWProtect(pScrn, FALSE);
     }
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98()) {
+       if (pMga->Chipset == PCI_CHIP_MGA2064)  outb(0xfac, 0x01);
+       else                                    outb(0xfac, 0x02);
+    }
+#endif
+
     /* Reset tagfifo*/ 
 	if (pMga->is_G200ER) 
     {
@@ -3659,6 +3671,10 @@
     MGARestore(pScrn);
     vgaHWLock(hwp);
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
 #ifdef MGADRI
     if (pMga->directRenderingEnabled) {
         pScreen = xf86ScrnToScreen(pScrn);
@@ -3755,6 +3771,10 @@
 
     pScrn->vtSema = FALSE;
 
+#if GET_ABI_MAJOR(ABI_VIDEODRV_VERSION) < 12
+    if (xf86IsPc98())  outb(0xfac, 0x00);
+#endif
+
     xf86ClearPrimInitDone(pScrn->entityList[0]);
 
     if(pMga->BlockHandler)
